{-# LANGUAGE CPP #-}
module NoSlow.Main.Tree
where

import NoSlow.Main.Util

kernel_tree
  = [ KModule "list"           "NoSlow.Micro.List"

#ifdef USE_DPH_PRIM_SEQ
    , KGroup "dph-prim" [
        KModule "seq"          "NoSlow.Micro.DPH.Prim.Seq"
      ]
#endif

#ifdef USE_VECTOR
    , KGroup "vector" [
        KModule "Primitive"    "NoSlow.Micro.Vector.Primitive"
      , KModule "Storable"     "NoSlow.Micro.Vector.Storable"
      , KModule "boxed"        "NoSlow.Micro.Vector.Boxed"
      ]
#endif

#ifdef USE_UVECTOR
    , KModule "uvector"        "NoSlow.Micro.Uvector"
#endif

#ifdef USE_STORABLEVECTOR
    , KModule "storablevector" "NoSlow.Micro.StorableVector"
#endif
    ]

